﻿local pt = AceLibrary("PeriodicTable-2.0")
Kennel = AceLibrary("AceAddon-2.0"):new("AceEvent-2.0","AceConsole-2.0")

function Kennel:OnInitialize()
	
end
function Kennel:OnEnable()
	self:RegisterEvent("BANKFRAME_OPENED")
	self:RegisterEvent("BANKFRAME_CLOSED")
end
function Kennel:OnDisable()
	self:UnregisterAllEvents()
end


----------------------------
--			Bank handling			--
----------------------------

function Kennel:BANKFRAME_OPENED()
	self.bankopen = true

	if self.combomode then self:ModeCombined()
	else self:ModeSeperate() end
end


function Kennel:BANKFRAME_CLOSED()
	if self.bankopen and self.swapped then
		--do these work anymore?
		--my hunch is no but, leaving em in.
		-- -nymbia
		if ZooKeeper then
			ZooKeeper:ActivatePet()
		end
		if FuBar_CorkFu then
			FuBar_CorkFu:GetModule("Minipet"):ActivatePet()
		end
	end
	self.bankopen = nil
end


function Kennel:ModeCombined()
	self.swapped = nil
	local r
	local p = Kennel:GetPets(nil, true)
	local b = Kennel:GetPets(true, true)

	if (table.getn(p) > table.getn(b)) then p, b = b, p end

	if (table.getn(p) > 0 and table.getn(b) > 0) then
		r = self:GetRandoms(table.getn(p), table.getn(b))
		for i,n in pairs(r) do self:Swap(p[i], b[n]) end
		self.swapped = true
	end
end


function Kennel:ModeSeperate()

	self.swapped = nil

	local rp, rph
	local pp, pph = Kennel:GetPets()
	local bp, bph = Kennel:GetPets(true)

	if (table.getn(pp) > table.getn(bp)) then pp, bp = bp, pp end
	if (table.getn(pph) > table.getn(bph)) then pph, bph = bph, pph end

	if (table.getn(pp) > 0 and table.getn(bp) > 0) then
		rp = self:GetRandoms(table.getn(pp), table.getn(bp))
		for i,n in pairs(rp) do self:Swap(pp[i], bp[n]) end
		self.swapped = true
	end

	if (table.getn(pph) > 0 and table.getn(bph) > 0) then
		rph = self:GetRandoms(table.getn(pph), table.getn(bph))
		for i,n in pairs(rph) do self:Swap(pph[i], bph[n]) end
		self.swapped = true
	end
end


function Kennel:GetPets(getbank, combined)
	
	local bags = getbank and {-1,5,6,7,8,9,10} or {0,1,2,3,4}
	local pets, hpets = {}, {}

	for i,bag in pairs(bags) do
		for slot=1,GetContainerNumSlots(bag) do
			local itemLink = GetContainerItemLink(bag, slot)
			if (itemLink and pt:ItemInSet(itemLink, "Minipet")) then
				table.insert(pets, {bag, slot})
			elseif (itemLink and pt:ItemInSet(itemLink, "Minipet - Holiday")) then
				if combined then table.insert(pets, {bag, slot})
				else table.insert(hpets, {bag, slot}) end
			end
		end
	end

	return pets, hpets
end


function Kennel:GetRandoms(num, total)

	local rands = {}

	if num > total then return end

	repeat
		local r = math.random(1,total)
		local f
		for i,n in pairs(rands) do if n == r then f=true end end
		if not f then table.insert(rands, r) end
	until (table.getn(rands) == num)
	return rands
end


function Kennel:Swap(item1, item2)
	local n1, n2
	if not item1 or not item2 then return end

	n1 = GetContainerItemLink(item1[1],item1[2]) or "[No Item]"
	n2 = GetContainerItemLink(item2[1],item2[2]) or "[No Item]"

	PickupContainerItem(item1[1],item1[2])
	PickupContainerItem(item2[1],item2[2])
end
